﻿package
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.ui.Mouse;
	Mouse.hide();

	public class Physics extends Sprite
	{
		private var nbr:Number = 70;// Nombre de boules
		public function Physics()
		{
			for(var i:Number=0;i<nbr;i++){
				var ball:Ball = new Ball();
				
				ball.x = Math.random()*600;
				ball.y = 100;
				ball.name = "ball"+i;
				addChild(ball);
			}
			//addEventListener(Event.ADDED_TO_STAGE,added_handler);
			
			
			var ball2:Ball2 = new Ball2();
			ball2.x = 20;
			ball2.y = 20;
			addChild(ball2);
		}
		private function added_handler(e:Event):void
		{
			stage.addEventListener(MouseEvent.CLICK,click_handler);
		}
		private function click_handler(e:MouseEvent):void
		{
			for(var i:Number=0;i<nbr;i++){
				var ball:Object =getChildByName("ball"+i);
				ball.x = Math.random()*stage.stageWidth;
				ball.y=100;
				ball.initialisation();
			}
		}
	}
}
import flash.display.Sprite;
import flash.events.Event;
import flash.geom.ColorTransform;
class Ball extends Sprite
{
	private var speedy:Number;
	private var speedx:Number;
	private var friction:Number;
	private var ax:Number;
	private var ay:Number;
	private var gravity:Number;
	private var distancex:Number; 
	private var distancey:Number;
	private var red:Number=0;
	private var green:Number=0;
	private var blue:Number=0;
	private var modulo:Number=10;
	private var positifNegatif:Number=1;
	
	
	
	public function Ball()
	{
		var biatch:Number = -30
		
		graphics.beginFill(0xFFFFFF,1);
		graphics.moveTo(biatch+0,biatch+0);
		graphics.lineTo(biatch+23,biatch+10);
		graphics.lineTo(biatch+50,biatch+0);
		graphics.lineTo(biatch+25,biatch+15);
		graphics.endFill();
		initialisation();
		addEventListener(Event.ENTER_FRAME, enter_handler);
	}
	
	public function initialisation():void
	{

		speedy = Math.random()*10;
		speedx = Math.random()*10;
		friction = 0.95;
		ax = 0;
		ay = 0;
		gravity = 0.9;
	}
	private function enter_handler(e:Event):void
	{
		
		red 	= -mouseY/300;
		green 	= 0.2;
		blue	= mouseY/70;
		
		//trace(red);
		distancex = ((mouseX / e.currentTarget.x)*1.5 + Math.round(Math.random()*6)-3 );
		distancey = ((mouseY / e.currentTarget.y)*2 + Math.round(Math.random()*6)-3)  ;
		
		speedy += gravity;			// à la vitesse vertical on aditionne la gravité
		//speedy += ay;				// à la vitesse vertical on additionne l'accélération
		//speedx += ax;	
		speedx += distancex;
		speedy += distancey;// à la vitesse horizontal on additionne l'accélération (il n'y a pas de gravité à l'horizontal)
		speedy *= friction;			// on multiplie la vitesse vertical par la friction (le freinage, l'effet de rebond)
		speedx *= friction;			// on multiplie la vitesse horizontale par la friction (le freinage, l'effet de rebond)
		e.currentTarget.y += speedy ;// on se déplace verticalement en rapport à la vitesse verticale calculée
		e.currentTarget.x += speedx ;// on se déplace horizontalement en rapport à la vitesse horizontale calculée	
		//trace(distancey);
		//trace(speedx);
		//trace(e.currentTarget.y);
		
		
		
		//si on touche les bords, on rebondit
		if((e.currentTarget.y + e.currentTarget.height/2)> stage.stageHeight){
			e.currentTarget.y = stage.stageHeight - e.currentTarget.height/2;
			speedy*=-1;
		}else if((e.currentTarget.y + e.currentTarget.height/2)< 0){
			e.currentTarget.y = e.currentTarget.height/2;
			speedy*=-1;
		}
		if (e.currentTarget.x + e.currentTarget.width/2 > stage.stageWidth) {
			e.currentTarget.x = stage.stageWidth - e.currentTarget.width/2;
			speedx *= -1;
		}else if (e.currentTarget.x - e.currentTarget.width/2 < 0) {
			e.currentTarget.x = e.currentTarget.width/2;
			speedx *= -1;
		} 
		e.currentTarget.transform.colorTransform = new ColorTransform(red,green,blue,1, 0, 1, 0, 0);
	}
}

import flash.display.Sprite;
import flash.events.Event;
import flash.geom.ColorTransform;
class Ball2 extends Sprite
{
	private var speedy:Number=5;
	private var speedx:Number=5;
	private var friction:Number;
	private var ax:Number;
	private var ay:Number;
	private var gravity:Number;
	private var distancex:Number; 
	private var distancey:Number;
	private var red:Number=0;
	private var green:Number=0;
	private var blue:Number=0;
	private var modulo:Number=10;
	private var positifNegatif:Number=1;
	
	
	public function Ball2()
	{
		var biatch:Number=0;
		trace(mouseX)
		
		var cursor : Sprite = new Sprite();
		cursor.graphics.beginFill(0xFFFFFF,1);
		cursor.graphics.moveTo(0,0);
		cursor.graphics.lineTo(23,10);
		cursor.graphics.lineTo(50,0);
		cursor.graphics.lineTo(25,15);
		cursor.graphics.endFill();
		addChild(cursor);
		cursor.addEventListener(Event.ENTER_FRAME, enter_handler2);

	}
	
	
	private function enter_handler2(e:Event):void
	{
		//e.currentTarget.x = mouseX+20;
		//trace(e.currentTarget.x + "______________" + mouseX);
		//e.currentTarget.y=mouseY+20;
		
		red 	= -mouseY/300;
		green 	= 0.2;
		blue	= mouseY/70;
		
		distancex = ( Math.round(Math.random()*30)-15 );
		distancey = (Math.round(Math.random()*30)-15)  ;
		
		speedy += 0.9;
		
		speedx += distancex;
		speedy += distancey;// à la vitesse horizontal on additionne l'accélération (il n'y a pas de gravité à l'horizontal)
		speedy *= 0.95;			// on multiplie la vitesse vertical par la friction (le freinage, l'effet de rebond)
		speedx *= 0.95;			// on multiplie la vitesse horizontale par la friction (le freinage, l'effet de rebond)
		e.currentTarget.x = mouseX + distancex ;// on se déplace verticalement en rapport à la vitesse verticale calculée
		e.currentTarget.y = mouseY + distancey ;
		
		
		
		trace(speedy)
		// on se déplace horizontalement en rapport à la vitesse horizontale calculée	
		
		//trace(e.currentTarget.y);
		
		
		/*
		//si on touche les bords, on rebondit
		if((e.currentTarget.y + e.currentTarget.height/2)> stage.stageHeight){
			e.currentTarget.y = stage.stageHeight - e.currentTarget.height/2;
			speedy*=-1;
		}else if((e.currentTarget.y + e.currentTarget.height/2)< 0){
			e.currentTarget.y = e.currentTarget.height/2;
			speedy*=-1;
		}
		if (e.currentTarget.x + e.currentTarget.width/2 > stage.stageWidth) {
			e.currentTarget.x = stage.stageWidth - e.currentTarget.width/2;
			speedx *= -1;
		}else if (e.currentTarget.x - e.currentTarget.width/2 < 0) {
			e.currentTarget.x = e.currentTarget.width/2;
			speedx *= -1;
		} 
		
		*/
		e.currentTarget.transform.colorTransform = new ColorTransform(red,green,blue,1, 0, 1, 0, 0);
	
	}
	
}